Qore Programming Language Reference Manual: Qore::HashReverseIterator Class Reference

Qore Programming Language Reference Manual 0.8.11

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Functions Variables Groups Pages
Public Member Functions | List of all members
Qore::HashReverseIterator Class Reference

This class an iterator class for hashes. More...

Inheritance diagram for Qore::HashReverseIterator:
[legend]

## Public Member Functions
| constructor (hash h)
| Creates the hash iterator object. More...
| constructor ()
| Creates an empty iterator object. More...
| copy ()
| Creates a copy of the HashReverseIterator object, iterating the same object as the original and in the same position. More...
bool | first ()
| returns True if on the last element of the hash More...
bool | last ()
| returns True if on the first element of the hash More...
bool | next ()
| Moves the current position to the previous element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the last element in the hash if the hash is not empty. More...
bool | prev ()
| Moves the current position to the next element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the first element in the hash if the hash is not empty. More...
Public Member Functions inherited from Qore::HashIterator
| constructor (hash h)
| Creates the hash iterator object. More...
| constructor ()
| Creates an empty hash iterator object. More...
| copy ()
| Creates a copy of the HashIterator object, iterating the same object as the original and in the same position. More...
bool | empty ()
| returns True if the hash is empty; False if not More...
string | getKey ()
| returns the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
any | getKeyValue ()
| returns the current value of the current has key being iterated or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
any | getValue ()
| returns the current key value or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
hash | getValuePair ()
| returns a hash with the current key and value (a hash with 2 keys: `"key"` and `"value"`) or throws an `INVALID-ITERATOR` exception if the iterator is invalid More...
| reset ()
| Reset the iterator instance to its initial state. More...
bool | valid ()
| returns True if the iterator is currently pointing at a valid element, False if not More...

## Detailed Description

This class an iterator class for hashes.

Call HashReverseIterator::next() to iterate through the hash in reverse order; do not use the iterator if HashReverseIterator::next() returns False. A hash can be iterated in reverse order by calling HashReverseIterator::prev() instead of HashReverseIterator::next()

Example: HashReverseIterator basic usage
  my hash $h = ( "key1" : 1, "key2" : 2, );
  my HashReverseIterator $it($h);
  while ($it.next()) {
  printf("getKey: %n; getKeyValue: %n; getValue: %n; getValuePair: %n\n",
  $it.getKey(), $it.getKeyValue(), $it.getValue(), $it.getValuePair());
  }
  getKey: "key2"; getKeyValue: 2; getValue: 2; getValuePair: hash: (key : "key2", value : 2)
  getKey: "key1"; getKeyValue: 1; getValue: 1; getValuePair: hash: (key : "key1", value : 1)

Note
  - In general, the HashReverseIterator class is not designed to be accessed from multiple threads; it was created without locking for fast and efficient use when used from a single thread. For methods that would be unsafe to use in another thread, any use of such methods in threads other than the thread where the constructor was called will cause an `ITERATOR-THREAD-ERROR` to be thrown.
  - HashReverseIterator is functionally equivalent to HashIterator, but the effect of HashReverseIterator::next() and HashReverseIterator::prev() are the opposite of HashIterator::next() and HashIterator::prev(); that is HashReverseIterator::next() will iterate through the hash in reverse order, while HashReverseIterator::prev() iterates in forward order. Additionally the meanings of the return values for HashReverseIterator::first() and HashReverseIterator::last() are swapped in respect to HashIterator::first() and HashIterator::last().

See Also
  HashIterator

## Member Function Documentation

Qore::HashReverseIterator::constructor | ( | hash | h | ) |

Creates the hash iterator object.

Parameters

  h | the hash to iterate

Example:
  my HashReverseIterator $hi($h);

Qore::HashReverseIterator::constructor | ( |  | ) |

Creates an empty iterator object.

Example:
  my *hash $h = get_hash_or_nothing();
  my HashReverseIterator $hi($h);

Qore::HashReverseIterator::copy | ( |  | ) |

Creates a copy of the HashReverseIterator object, iterating the same object as the original and in the same position.

Example:
  my HashReverseIterator $ni = $i.copy();

bool Qore::HashReverseIterator::first | ( |  | ) |
| virtual

returns True if on the last element of the hash

Returns
  True if on the last element of the hash

Code Flags:
  CONSTANT

Example:
  while ($i.next()) {
  if ($i.first())
  printf("START:\n");
  }

Reimplemented from Qore::HashIterator.

bool Qore::HashReverseIterator::last | ( |  | ) |
| virtual

returns True if on the first element of the hash

Returns
  True if on the first element of the hash

Code Flags:
  CONSTANT

Example:
  while ($i.next()) {
  if ($i.last())
  printf("END.\n");
  }

Reimplemented from Qore::HashIterator.

bool Qore::HashReverseIterator::next | ( |  | ) |
| virtual

Moves the current position to the previous element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the last element in the hash if the hash is not empty.

This method will return True again after it returns False once if the hash is not empty, otherwise it will always return False. The iterator object should not be used after this method returns False

Returns
  False if there are no more elements in the hash (in which case the iterator object is invalid and should not be used); True if successful (meaning that the iterator object is valid)

Example:
  while ($i.prev()) {
  printf(" + %y\n", $i.getValue());
  }

Note
  HashReverseIterator::next() is the opposite of HashIterator::next(); it is functionally equivalent to HashIterator::prev(); HashReverseIterator::next() iterates through the hash in reverse order

Exceptions

  ITERATOR-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Reimplemented from Qore::HashIterator.

bool Qore::HashReverseIterator::prev | ( |  | ) |
| virtual

Moves the current position to the next element in the hash; returns False if there are no more elements; if the iterator is not pointing at a valid element before this call, the iterator will be positioned on the first element in the hash if the hash is not empty.

This method will return True again after it returns False once if hash is not empty, otherwise it will always return False. The iterator object should not be used after this method returns False

Returns
  False if there are no more elements in the hash (in which case the iterator object is invalid and should not be used); True if successful (meaning that the iterator object is valid)

Example:
  while ($i.next()) {
  printf(" + %y\n", $i.getValue());
  }

Note
  HashReverseIterator::prev() is the opposite of HashIterator::prev(); it is functionally equivalent to HashIterator::next(); HashReverseIterator::prev() iterates through the hash in forward order

Exceptions

  ITERATOR-THREAD-ERROR | this exception is thrown if this method is called from any thread other than the thread that created the object

Reimplemented from Qore::HashIterator.